      PROGRAM COLLFILE
c
c  This programme was developed and programmed by Helmut Vincke
c  Adapted for >= FLUKA 2008.3 by C. Theis
c  
c
      CHARACTER INPFILE*80,CADFILE*87,PARTNAME*3
      INTEGER INDICATE,NTRACK, MTRACK, JTRACK,ICODE,HISTORY,CONST,LOOP,
     + KINORTOT,LASTWRITE,LINLOG,BINNUM,NCASE,num,LSTACK, LSTMAX,
     + ILO(0:100000), PARTTYPE
      DOUBLE PRECISION ETRACK,WTRACK,XTRACK(0:100000),YTRACK(0:100000),
     +ZTRACK(0:100000),XSCO,YSCO,ZSCO,RADIUS,
     +RULL,TKESUM,WEIPRI,ETOT
     +(0:100000),WT(0:100000),XA(0:100000),FACTOR,
     +YA(0:100000), ZA(0:100000),ALLPART,ATRACK, 
     +EMIN,EMAX, MASS(-6:42),EMINOLD,EMAXOLD,
     +TXFLK(0:100000),TYFLK(0:100000),TZFLK(0:100000),
     +AGESTK(0:100000)
c
c Masse der einzelnen Teilchen in GeV
c
      mass (-6)=0.3727380257E+01
      mass (-5)=0.2808392237E+01
      mass (-4)=0.2808921774E+01
      mass (-3)=0.1875613390E+01
      mass (-2)=0.0000000000E+00
      mass (-1)=0.0000000000E+00
      mass ( 0)=0.0000000000E+00
      mass ( 1)=0.9382723100E+00
      mass ( 2)=0.9382723100E+00
      mass ( 3)=0.5109990600E-03
      mass ( 4)=0.5109990600E-03
      mass ( 5)=0.0000000000E+00
      mass ( 6)=0.0000000000E+00
      mass ( 7)=0.0000000000E+00
      mass ( 8)=0.9395656300E+00
      mass ( 9)=0.9395656300E+00
      mass (10)=0.1056583890E+00
      mass (11)=0.1056583890E+00
      mass (12)=0.4976710000E+00
      mass (13)=0.1395699500E+00
      mass (14)=0.1395699500E+00
      mass (15)=0.4936460000E+00
      mass (16)=0.4936460000E+00
      mass (17)=0.1115630000E+01
      mass (18)=0.1115630000E+01
      mass (19)=0.4976710000E+00
      mass (20)=0.1197430000E+01
      mass (21)=0.1189370000E+01
      mass (22)=0.1192550000E+01
      mass (23)=0.1349764000E+00
      mass (24)=0.4976710000E+00
      mass (25)=0.4976710000E+00
      mass (26)=0.1349764000E+00
      mass (27)=0.0000000000E+00
      mass (28)=0.0000000000E+00
      mass (29)=0.5474500000E+00
      mass (30)=0.0000000000E+00
      mass (31)=0.1189370000E+01
      mass (32)=0.1192550000E+01
      mass (33)=0.1197430000E+01
      mass (34)=0.1314900000E+01
      mass (35)=0.1314900000E+01
      mass (36)=0.1321320000E+01
      mass (37)=0.1321320000E+01
      mass (38)=0.1672430000E+01
      mass (39)=0.1672430000E+01
      mass (40)=0.9395656300E+00
      mass (41)=0.1777000000E+01
      mass (42)=0.1777000000E+01
C
      WRITE(*,*)'                  PIPSICAD                    '
      WRITE(*,*)'                                              '
      WRITE(*,*)'This Programme was developed und programmed by'
      WRITE(*,*)'                                              '
      WRITE(*,*)'               HELMUT VINCKE                  '
      WRITE(*,*)'                                              '
      WRITE(*,*)'    You can find information about it in:     '
      WRITE(*,*)'    http://home.cern.ch/~vincke/heli.htm      '
      WRITE(*,*)'                                              '
      WRITE(*,*)'                                              '
      WRITE(*,*)' Version: 2.1.3 -  6.7.2010                   '
C
C    Programm fragt nach dem Fluka Inputfilenamen bzw. nach dem CADFILENAMEN UM
C    IM OPEN BEFEHL DEN RICHTIGEN FILENAMEN ANZUGEBEN. Weiters wird nach dem zu 
C    zeichnenden Energiebereich (kin. oder gesammte Energie) und nach den zu 
C    zeichnenden Teilchen gefragt.
C
      WRITE(*,*)'NAME OF FLUKA-COLLISIONFILE [collfile]????'
      READ(*,'(A80)') INPFILE
      WRITE(*,*)' '
      IF (INPFILE.EQ.' ') THEN
       INPFILE='collfile'
      ENDIF 
c
c     Production of cadfile name
      num= INDEX (INPFILE,'   ')-1
      IF (num.ne.0) then
        CADFILE = INPFILE(1:num)//'.tracks'
      else
        CADFILE = INPFILE//'.tracks'
      endif	
c
C
C    Offnen des Collision files aus Fluka, des CAD outputfiles und des 
C    Files, auf den Teilchenparameter herausgeschrieben werden.
C
      OPEN(17,FILE=INPFILE,STATUS='OLD',FORM='UNFORMATTED')
      OPEN(25,FILE='collfile.scr',STATUS='UNKNOWN',FORM='FORMATTED')
      OPEN(35,FILE=CADFILE,STATUS='UNKNOWN',FORM='FORMATTED')
      ALLPART=0.0
      KINORTOT=0
      PARTNAME='ALL'
      WRITE(*,*)'Total energy or kinetic energy'
      WRITE(*,*)'            *******           '
      WRITE(*,*)'For total energy:   press return only'
      WRITE(*,*)'For kinetic energy: press 1 followed by return '
      READ(*,'(I1)') KINORTOT
      IF(KINORTOT.EQ.0) THEN
       WRITE(*,*)'ENTER THE WISHED MINIMUM TOTAL ENERGY OF THE '
       WRITE(*,*)'PARTICLES IN GEV'
         READ(*,'(D16.0)') EMIN
       WRITE(*,*)'ENTER THE WISHED MAXIMUM TOTAL ENERGY OF THE '
       WRITE(*,*)'PARTICLES IN GEV'
         READ(*,'(D16.0)') EMAX      
       IF (EMAX.EQ.0.0) THEN
        EMAX=100000.0
       ENDIF 
      ELSE
       WRITE(*,*)'ENTER THE WISHED MINIMUM KIN. ENERGY OF THE PARTICLES'
       WRITE(*,*)'IN GEV'
         READ(*,'(D16.0)') EMIN
       WRITE(*,*)'ENTER THE WISHED MAXIMUM KIN. ENERGY OF THE PARTICLES'
       WRITE(*,*)'IN GEV'
         READ(*,'(D16.0)') EMAX      
       IF (EMAX.EQ.0.0) THEN
        EMAX=100000.0
       ENDIF 
      ENDIF
  126  CONTINUE
       WRITE(*,*)'ENTER THE NUMBER OF ENERGY BINS'
         READ(*,'(I5)') BINNUM      
       IF((BINNUM.GT.1000).OR.(BINNUM.LT.1)) THEN
        write(*,*) 'BINNUMBER SHOULD BE BELOW 1000 AND ABOVE 0'
	GOTO 126
       ENDIF	
       WRITE(*,*)'Lin. or log. BINNING? '
       WRITE(*,*)'FOR LOG. BINNING: 1 FOLLOWED BY RETURN  '
       WRITE(*,*)'FOR LIN. BINNING: RETURN ONLY '
         READ(*,'(I1)') LINLOG      

      IF( LINLOG.EQ. 1 .AND. EMIN.EQ.0.D0) THEN       
        EMIN=1.0E-14
	WRITE(*,*) '*** WARNING: Emin = 0.0 not allowed for logarithmic binning'
	WRITE(*,*) '***          default Emin = 1.0E-14 used'
      ENDIF 
 
      CALL GROUPCALC(LINLOG,EMIN,EMAX,BINNUM,KINORTOT)	 
      EMINOLD=EMIN 
      EMAXOLD=EMAX 
      LOOP=0
      LASTWRITE=0
      
      
      WRITE(*,*)'Enter particle type number (ALL = RETURN ONLY):'
        READ(*,'(I1)') PARTTYPE
      
c
 300  CONTINUE
      LOOP=LOOP+1
      REWIND 17
C
C   ZWISCHEN 100 UND GOTO 100 WIRD DER GANZE FILE SCHRITTWEISE AUSGELESEN
C   UND ABGEARBEITET. FUER PUNKTFOERMIGE ENERGIEDEPOSITIONEN WIRD COLLCAD1
C   ANSONSTEN COLLCAD AUFGERUFEN.
C
 100  CONTINUE
 
      READ(17,END=200) INDICATE   
     
      BACKSPACE 17
      IF (INDICATE .GT. 0) THEN

        READ(17,END=200) NTRACK, MTRACK, JTRACK, ETRACK, WTRACK, NCASE
        READ(17,END=200) (XTRACK(I),YTRACK(I),ZTRACK(I), ATRACK, 
     &   I = 0,NTRACK)   
     
c	WRITE(*,*) NTRACK, MTRACK, JTRACK, ETRACK, WTRACK, NCASE
c	WRITE(*,*) (XTRACK(I),YTRACK(I),ZTRACK(I), ATRACK, 
c     &   I = 0,NTRACK)   
	
	     
        IF (LOOP .NE. 1) GOTO 150
	
c check if all particles were selected or a filter for one type
* is applicable.	
	IF( PARTTYPE .NE. 0 .AND. JTRACK .NE. PARTTYPE) GOTO 150
c
        IF (KINORTOT.EQ.1 .AND. JTRACK.GE.-6 .AND.JTRACK.LE.42) THEN
	 EMINOLD=EMIN 
	 EMAXOLD=EMAX 
	 EMIN=EMIN+MASS(JTRACK)
	 EMAX=EMAX+MASS(JTRACK)
	ENDIF
          IF((ETRACK.GE.EMIN).AND.(ETRACK.LE.EMAX)) THEN
           CALL COLLCAD_CHRIS(XTRACK,YTRACK,ZTRACK,NTRACK,MTRACK,JTRACK,
     +     ETRACK,WTRACK,PARTNAME,HISTORY,KINORTOT,ATRACK,NCASE)
           CALL COLLCAD(XTRACK,YTRACK,ZTRACK,NTRACK,MTRACK,JTRACK,
     +     ETRACK,WTRACK,PARTNAME,HISTORY)
          ENDIF
      ELSEIF (INDICATE .EQ. 0) THEN
      	      
        READ(17,END=200) INDICATE,ICODE,JTRACK,ETRACK,WTRACK
        READ(17,END=200) XSCO,YSCO,ZSCO,RULL
        IF (LOOP .NE. 2) GOTO 150
c
        IF (KINORTOT.EQ.1 .AND. JTRACK.GE.-6 .AND.JTRACK.LE.42) THEN
	 EMINOLD=EMIN 
	 EMAXOLD=EMAX 
	 EMIN=EMIN+MASS(JTRACK)
	 EMAX=EMAX+MASS(JTRACK)
	ENDIF
c
          IF((ETRACK.GE.EMIN).AND.(ETRACK.LE.EMAX)) THEN
           CALL COLLCAD1(ICODE, JTRACK,ETRACK,WTRACK,XSCO,YSCO,ZSCO,
     +     RULL,PARTNAME,HISTORY,RADIUS,CONST,FACTOR)
           LASTWRITE=1
          ENDIF
      ELSEIF (INDICATE .LT. 0) THEN
      
	
*        READ(17,END=200) NCASE, LSTACK, LSTMAX, TKESUM, WEIPRI
*        READ(17,END=200) (ILO(I),ETOT(I),WT(I),XA(I),YA(I),ZA(I), I = 1
*     +, LSTACK)

*
* New format for the case of source particles (FLUKA 2008.3 onwards)
*
        READ(17,END=200) NCASE, LSTACK, LSTMAX, TKESUM, WEIPRI
c        WRITE(*,*) 'DEBUG5a'	
c	WRITE(*,*) NCASE, LSTACK, LSTMAX, TKESUM, WEIPRI
	
        READ(17,END=200) (ILO(I),ETOT(I),WT(I),XA(I),YA(I),ZA(I),
     &	                 TXFLK(I), TYFLK(I), TZFLK(I),AGESTK(I), I = 1
     +, LSTACK)

c        WRITE(*,*) (ILO(I),ETOT(I),WT(I),XA(I),YA(I),ZA(I),
c     &	                 TXFLK(I), TYFLK(I), TZFLK(I),AGESTK(I), I = 1
c     +, LSTACK)


      ENDIF 
 150  CONTINUE
      IF (KINORTOT.EQ.1) THEN
       EMIN=EMINOLD
       EMAX=EMAXOLD
      ENDIF 
      GOTO 100
 200  CONTINUE
      IF (LOOP .EQ. 3) GOTO 400 
      GOTO 300
 400  CONTINUE     
      IF (LASTWRITE.EQ.0) THEN
      WRITE(25,'()')
      ENDIF
      END
